/*	RCT3 libOVL
	Copyright 2005 Jonathan Wilson

	This file is part of the RCT3 libOVL
	The RCT3 libOVL library is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
*/

#ifndef __libOVL_OVL_Stall_h__
#define __libOVL_OVL_Stall_h__

struct StallItem
{
	unsigned char *CID;
	unsigned long unk1; //cost?
};
struct Attraction
{
	unsigned long unk1;
	wchar_t* Name;
	wchar_t* Description;
	GUISkinItem *GSI;
	unsigned long unk2;
	unsigned long unk3;
	unsigned long unk4;
	unsigned long unk5;
	unsigned long unk6;
	unsigned char *spline;
	unsigned long unk7;
	unsigned long unk8;
	unsigned long unk9;
	unsigned long unk10;
	unsigned long unk11;
	unsigned long unk12;
};
struct Stall
{
	unsigned long unk1;
	wchar_t* Name;
	wchar_t* Description;
	GUISkinItem *GSI;
	unsigned long unk2;
	unsigned long unk3;
	unsigned long unk4;
	unsigned long unk5;
	unsigned long unk6;
	unsigned char *spline;
	unsigned long unk7;
	unsigned long unk8;
	unsigned long unk9;
	unsigned long unk10;
	SceneryItem *SID;
	unsigned long itemcount;
	StallItem *Items;
	unsigned long unk11;
	unsigned long unk12;
	unsigned long unk13;
	unsigned long unk14;
	unsigned long unk15;
	unsigned long unk16;
};
struct Stall2
{
	unsigned long unk1;
	unsigned long itemcount;
	StallItem *Items;
	unsigned long unk2;
	unsigned long unk3;
	unsigned long unk4;
	unsigned long unk5;
	unsigned long unk6;
	unsigned long unk7;
	Attraction *att;
	SceneryItem *SID;
};
struct ChangingRoom
{
	Attraction *att;
	SceneryItem *SID;
	unsigned char *spline;
};
struct SpecialAttraction2
{
	unsigned long unk;
	Attraction *att;
	SceneryItem *SID;
};
struct SpecialAttraction
{
	unsigned long unk1;
	wchar_t* Name;
	wchar_t* Description;
	GUISkinItem *GSI;
	unsigned long unk2;
	unsigned long unk3;
	unsigned long unk4;
	unsigned long unk5;
	unsigned long unk6;
	unsigned char *spline;
	unsigned long unk7;
	unsigned long unk8;
	unsigned long unk9;
	unsigned long unk10;
	SceneryItem *SID;
};

#endif
